(*****************************************************************************
 *                          W A R N I N G          
 *
 * Information in this file will be updated by the packaging process, 
 * respectively the owner of the build process. 
 * Please, DO NOT EDIT THIS FILE MANUALLY. 
 ******************************************************************************)

(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *                                                                            
 * config.sml  --- main configuration file for HOL-TestGen
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2005-2007 ETH Zurich, Switzerland
 *               2013 Achim D. Brucker, Germany
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)


(** Major version number.
 * 
 * Modify when incompatible changes are made to published interfaces.
 *)
val testgen_ver_major = 1 

(* Minor version number.
 *
 * Modify when new functionality is added or new interfaces are defined, 
 * but all changes are backward compatible.
 *)
val testgen_ver_minor = 9 

(** Patch number.
 *
 * Modify for every released patch.
 *)
val testgen_ver_micro= 1

(** Version tag: a string describing the version.
 *
 * This tag remains " (dev build: <number>)" in the repository so that we can
 * always see from "version" that the software has been built from the 
 * repository rather than a "blessed" distribution.
 *
 * When rolling a tarball, we automatically replace this text with 
 * " (build: <number>" for final releases; in prereleases, it becomes 
 * " (Alpha: <number>)", " (Beta <number>)", etc., as appropriate.
 *)
val testgen_ver_tag = " (development build)"

(** Supported Isabelle version. 
 *
 * If build with a different version, a warning during the build 
 * process is displayed. 
 *)

val isabelle_version = "Isabelle2016-1: December 2016"

(** URL of the HOL-TestGen Homepage.
 *
 *)
val testgen_url = "http://www.brucker.ch/projects/hol-testgen/"
